var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  STORE_CONTEXT: () => STORE_CONTEXT,
  STORE_LOCAL_CONTEXT: () => STORE_LOCAL_CONTEXT,
  createInspect: () => createInspect,
  createManager: () => createManager,
  createStore: () => createStore,
  createStoreDevTool: () => createStoreDevTool,
  createTree: () => createTree,
  createTreeMultiple: () => createTreeMultiple,
  createVare: () => createVare,
  createVareStore: () => createVareStore,
  defineStore: () => defineStore,
  provideStoreManager: () => provideStoreManager,
  useLocalManager: () => useLocalManager,
  useStore: () => useStore,
  useStoreManager: () => useStoreManager
});
module.exports = __toCommonJS(src_exports);

// src/store/index.ts
var import_vue_demi4 = require("vue-demi");

// src/store/manager.ts
var import_utils = require("@winter-love/utils");
var import_vue_demi = require("vue-demi");

// src/store/symbols.ts
var STORE_CONTEXT = Symbol("store");
var STORE_LOCAL_CONTEXT = Symbol("store-local");

// src/store/manager.ts
var useStoreManager = () => {
  var _a;
  return (_a = (0, import_vue_demi.inject)(STORE_CONTEXT)) != null ? _a : createManager();
};
var { assign } = Object;
var createManager = (info) => {
  const storeTree = (0, import_vue_demi.reactive)({});
  const state = (0, import_vue_demi.computed)(() => storeTree);
  const _info = (0, import_utils.freeze)(info);
  const store = (0, import_utils.freeze)({
    info: _info,
    tree: storeTree
  });
  const initState = {};
  const storePropsMap = /* @__PURE__ */ new Map();
  const set = (name, item) => {
    storeTree[name] = item.state;
  };
  const remove = (name) => {
    storeTree[name] = void 0;
    storePropsMap.delete(name);
  };
  const get = (name) => {
    const state2 = storeTree[name];
    if (!state2) {
      return;
    }
    return {
      state: state2
    };
  };
  const setInitState = (state2 = {}) => {
    assign(initState, state2);
  };
  return {
    get,
    initState,
    remove,
    set,
    setInitState,
    state,
    store
  };
};

// src/store/dev-tool.ts
var import_devtools_api = require("@vue/devtools-api");
var import_utils2 = require("@winter-love/utils");
var import_vue_demi2 = require("vue-demi");
var tagThemes = {
  "local-state": {
    backgroundColor: 7580670,
    label: "local state",
    textColor: 0
  },
  state: {
    backgroundColor: 394748,
    label: "state",
    textColor: 0
  },
  unknown: {
    backgroundColor: 16758528,
    label: "unknown",
    textColor: 0
  }
};
var createTree = (store, index = 0) => {
  const { info, tree } = store;
  return Object.keys(tree).map((key) => {
    var _a;
    const itemInfo = (0, import_utils2.parseJson)(key, key);
    const tag = typeof itemInfo === "string" ? [] : [
      {
        backgroundColor: 10066329,
        label: `for: ${itemInfo.componentName}`,
        textColor: 0
      },
      {
        backgroundColor: 10066329,
        label: itemInfo.uid,
        textColor: 0
      }
    ];
    return {
      id: JSON.stringify({
        index,
        key
      }),
      label: typeof itemInfo === "string" ? itemInfo : itemInfo.name,
      tags: [
        __spreadValues({}, tagThemes[(_a = info == null ? void 0 : info.kind) != null ? _a : "unknown"]),
        ...tag
      ]
    };
  });
};
var createTreeMultiple = (...stores) => {
  return stores.flatMap((store, index) => {
    return createTree(store, index);
  });
};
var createInspect = (name, state) => {
  const itemInfo = (0, import_utils2.parseJson)(name, name);
  return {
    state: [
      {
        editable: true,
        key: typeof itemInfo === "string" ? itemInfo : itemInfo.name,
        objectType: "reactive",
        value: state
      }
    ]
  };
};
var createStoreDevTool = (app, stores) => {
  const inspectId = "vare-inspect";
  const timeLineId = "vare-event";
  const label = "vare-store";
  const _stores = (0, import_utils2.toArray)(stores);
  (0, import_devtools_api.setupDevtoolsPlugin)({
    app,
    id: "vare-store",
    label: "vare-store",
    packageName: "vare"
  }, (api) => {
    api.addInspector({
      icon: "mediation",
      id: inspectId,
      label: `${label} Structure`
    });
    api.addTimelineLayer({
      color: 15764809,
      id: timeLineId,
      label: "Vare Changing"
    });
    api.on.getInspectorTree((payload) => {
      if (payload.app !== app || payload.inspectorId !== inspectId) {
        return;
      }
      payload.rootNodes = createTreeMultiple(..._stores);
    });
    api.on.getInspectorState((payload) => {
      if (payload.app !== app || payload.inspectorId !== inspectId) {
        return;
      }
      const name = payload.nodeId;
      const { key, index } = (0, import_utils2.parseJson)(name, { index: 0, key: name });
      const state = _stores[index].tree[key];
      if (state) {
        payload.state = createInspect(key, state);
      }
    });
    api.on.editInspectorState((payload) => {
      if (payload.app !== app || payload.inspectorId !== inspectId) {
        return;
      }
      const name = payload.nodeId;
      const { key, index } = (0, import_utils2.parseJson)(name, { index: 0, key: name });
      const state = _stores[index].tree[key];
      if (state) {
        const path = (0, import_utils2.drop)(1)(payload.path);
        const { value } = payload.state;
        payload.set(state, path, value);
      }
    });
    Object.keys(_stores).forEach((name) => {
      const store = _stores[name];
      (0, import_vue_demi2.watch)(store.tree, () => {
        api.addTimelineEvent({
          event: {
            data: typeof store.tree === "object" ? __spreadValues({}, store.tree) : store.tree,
            time: Date.now()
          },
          layerId: timeLineId
        });
      });
    });
  });
};

// src/store/store.ts
var import_utils3 = require("@winter-love/utils");
var import_vue_demi3 = require("vue-demi");

// src/store/create-uuid.ts
var createUuid = () => {
  let count = 0;
  return () => {
    count += 1;
    return count;
  };
};

// src/store/store.ts
var getUuid = createUuid();
var createSetup = (args) => {
  const { setup, storeManager, initState } = args;
  return {
    state: (0, import_vue_demi3.reactive)(setup(initState != null ? initState : {}, storeManager.state.value))
  };
};
var createLocalStore = (args) => {
  var _a, _b, _c;
  const { name, storeManager, setup } = args;
  const item = createSetup({
    initState: {},
    setup,
    storeManager
  });
  const instance = (0, import_vue_demi3.getCurrentInstance)();
  const uid = instance ? instance.uid : getUuid();
  const componentName = (_c = (_b = (_a = instance == null ? void 0 : instance.ctx) == null ? void 0 : _a.$options) == null ? void 0 : _b.name) != null ? _c : "Undefined Name";
  const uuidName = process.env.NODE_ENV === "production" ? `${uid}` : JSON.stringify({
    componentName,
    name,
    uid
  });
  const localStoreManager = useLocalManager();
  if (localStoreManager) {
    localStoreManager.set(uuidName, item);
  }
  (0, import_vue_demi3.onScopeDispose)(() => {
    localStoreManager == null ? void 0 : localStoreManager.remove(uuidName);
  });
  return item.state;
};
var createGlobalStore = (args) => {
  var _a;
  const { name, options, storeManager, setup } = args;
  const { reset } = options;
  const savedState = storeManager.get(name);
  if (savedState && !reset) {
    return savedState.state;
  }
  const initState = (0, import_vue_demi3.toRaw)((_a = storeManager.initState[name]) != null ? _a : {});
  const newState = createSetup({
    initState,
    setup,
    storeManager
  });
  storeManager.set(name, newState);
  return newState.state;
};
var useLocalManager = () => {
  return (0, import_vue_demi3.inject)(STORE_LOCAL_CONTEXT);
};
var getOptions = (arg1, arg2) => {
  if (typeof arg1 === "string" && typeof arg2 !== "undefined") {
    return {
      name: arg1,
      setup: arg2
    };
  }
  if (typeof arg1 === "object" && typeof arg2 === "undefined") {
    return arg1;
  }
  throw new Error("params error");
};
function defineStore(arg1, arg2) {
  const {
    name,
    setup,
    local
  } = getOptions(arg1, arg2);
  const hook = (options = {}) => {
    const { local: innerLocal = local } = options;
    const storeManager = useStoreManager();
    if (innerLocal) {
      return createLocalStore({ name, setup, storeManager });
    }
    return createGlobalStore({
      name,
      options,
      setup,
      storeManager
    });
  };
  return (0, import_utils3.freeze)(Object.assign(hook, {
    local: (options = {}) => hook(__spreadProps(__spreadValues({}, options), { local: true }))
  }));
}
function createStore(arg1, arg2) {
  return defineStore(arg1, arg2);
}
function useStore(arg1, arg2) {
  return createStore(arg1, arg2)();
}

// src/store/index.ts
var createVare = () => {
  const manager = createManager({
    kind: "state"
  });
  const localManager = createManager({
    kind: "local-state"
  });
  return (0, import_vue_demi4.markRaw)({
    install: (app, options = {}) => {
      const { plugins = [], initState } = options;
      manager.setInitState(initState);
      plugins.forEach((plugin) => {
        plugin(manager.state, manager.store.info);
      });
      app.provide(STORE_CONTEXT, manager);
      app.provide(STORE_LOCAL_CONTEXT, localManager);
    },
    localManager,
    manager,
    state: manager.state
  });
};
var createVareStore = createVare;
var provideStoreManager = (manager, localManager) => {
  (0, import_vue_demi4.provide)(STORE_CONTEXT, manager != null ? manager : createManager());
  if (process.env.NODE_ENV !== "production") {
    (0, import_vue_demi4.provide)(STORE_LOCAL_CONTEXT, localManager);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  STORE_CONTEXT,
  STORE_LOCAL_CONTEXT,
  createInspect,
  createManager,
  createStore,
  createStoreDevTool,
  createTree,
  createTreeMultiple,
  createVare,
  createVareStore,
  defineStore,
  provideStoreManager,
  useLocalManager,
  useStore,
  useStoreManager
});
//# sourceMappingURL=index.js.map